var L = Object.defineProperty;
var B = (e, t, r) => t in e ? L(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r;
var h = (e, t, r) => (B(e, typeof t != "symbol" ? t + "" : t, r), r), K = (e, t, r) => {
  if (!t.has(e))
    throw TypeError("Cannot " + r);
};
var $ = (e, t, r) => {
  if (t.has(e))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(e) : t.set(e, r);
};
var y = (e, t, r) => (K(e, t, "access private method"), r);
import { klona } from "klona";
import { isRef, isReactive, getCurrentScope, onScopeDispose, ref, watch } from "vue";
function getDevtoolsGlobalHook() {
  return getTarget().__VUE_DEVTOOLS_GLOBAL_HOOK__;
}
function getTarget() {
  return typeof navigator < "u" && typeof window < "u" ? window : typeof global < "u" ? global : {};
}
const isProxyAvailable = typeof Proxy == "function", HOOK_SETUP = "devtools-plugin:setup", HOOK_PLUGIN_SETTINGS_SET = "plugin:settings:set";
let supported, perf;
function isPerformanceSupported() {
  var e;
  return supported !== void 0 || (typeof window < "u" && window.performance ? (supported = !0, perf = window.performance) : typeof global < "u" && ((e = global.perf_hooks) === null || e === void 0 ? void 0 : e.performance) ? (supported = !0, perf = global.perf_hooks.performance) : supported = !1), supported;
}
function now$1() {
  return isPerformanceSupported() ? perf.now() : Date.now();
}
class ApiProxy {
  constructor(t, r) {
    this.target = null, this.targetQueue = [], this.onQueue = [], this.plugin = t, this.hook = r;
    const n = {};
    if (t.settings)
      for (const a in t.settings) {
        const l = t.settings[a];
        n[a] = l.defaultValue;
      }
    const o = `__vue-devtools-plugin-settings__${t.id}`;
    let s = Object.assign({}, n);
    try {
      const a = localStorage.getItem(o), l = JSON.parse(a);
      Object.assign(s, l);
    } catch {
    }
    this.fallbacks = {
      getSettings() {
        return s;
      },
      setSettings(a) {
        try {
          localStorage.setItem(o, JSON.stringify(a));
        } catch {
        }
        s = a;
      },
      now() {
        return now$1();
      }
    }, r && r.on(HOOK_PLUGIN_SETTINGS_SET, (a, l) => {
      a === this.plugin.id && this.fallbacks.setSettings(l);
    }), this.proxiedOn = new Proxy({}, {
      get: (a, l) => this.target ? this.target.on[l] : (...u) => {
        this.onQueue.push({
          method: l,
          args: u
        });
      }
    }), this.proxiedTarget = new Proxy({}, {
      get: (a, l) => this.target ? this.target[l] : l === "on" ? this.proxiedOn : Object.keys(this.fallbacks).includes(l) ? (...u) => (this.targetQueue.push({
        method: l,
        args: u,
        resolve: () => {
        }
      }), this.fallbacks[l](...u)) : (...u) => new Promise((d) => {
        this.targetQueue.push({
          method: l,
          args: u,
          resolve: d
        });
      })
    });
  }
  async setRealTarget(t) {
    this.target = t;
    for (const r of this.onQueue)
      this.target.on[r.method](...r.args);
    for (const r of this.targetQueue)
      r.resolve(await this.target[r.method](...r.args));
  }
}
function setupDevtoolsPlugin(e, t) {
  const r = e, n = getTarget(), o = getDevtoolsGlobalHook(), s = isProxyAvailable && r.enableEarlyProxy;
  if (o && (n.__VUE_DEVTOOLS_PLUGIN_API_AVAILABLE__ || !s))
    o.emit(HOOK_SETUP, e, t);
  else {
    const a = s ? new ApiProxy(r, o) : null;
    (n.__VUE_DEVTOOLS_PLUGINS__ = n.__VUE_DEVTOOLS_PLUGINS__ || []).push({
      pluginDescriptor: r,
      setupFn: t,
      proxy: a
    }), a && t(a.proxiedTarget);
  }
}
var commonjsGlobal = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, FUNC_ERROR_TEXT$2 = "Expected a function", NAN = 0 / 0, symbolTag$2 = "[object Symbol]", reTrim = /^\s+|\s+$/g, reIsBadHex = /^[-+]0x[0-9a-f]+$/i, reIsBinary = /^0b[01]+$/i, reIsOctal = /^0o[0-7]+$/i, freeParseInt = parseInt, freeGlobal$2 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal, freeSelf$2 = typeof self == "object" && self && self.Object === Object && self, root$2 = freeGlobal$2 || freeSelf$2 || Function("return this")(), objectProto$3 = Object.prototype, objectToString$2 = objectProto$3.toString, nativeMax = Math.max, nativeMin = Math.min, now = function() {
  return root$2.Date.now();
};
function debounce(e, t, r) {
  var n, o, s, a, l, u, d = 0, b = !1, m = !1, g = !0;
  if (typeof e != "function")
    throw new TypeError(FUNC_ERROR_TEXT$2);
  t = toNumber(t) || 0, isObject$2(r) && (b = !!r.leading, m = "maxWait" in r, s = m ? nativeMax(toNumber(r.maxWait) || 0, t) : s, g = "trailing" in r ? !!r.trailing : g);
  function p(f) {
    var _ = n, S = o;
    return n = o = void 0, d = f, a = e.apply(S, _), a;
  }
  function F(f) {
    return d = f, l = setTimeout(P, t), b ? p(f) : a;
  }
  function G(f) {
    var _ = f - u, S = f - d, x = t - _;
    return m ? nativeMin(x, s - S) : x;
  }
  function D(f) {
    var _ = f - u, S = f - d;
    return u === void 0 || _ >= t || _ < 0 || m && S >= s;
  }
  function P() {
    var f = now();
    if (D(f))
      return E(f);
    l = setTimeout(P, G(f));
  }
  function E(f) {
    return l = void 0, g && n ? p(f) : (n = o = void 0, a);
  }
  function H() {
    l !== void 0 && clearTimeout(l), d = 0, n = u = o = l = void 0;
  }
  function k() {
    return l === void 0 ? a : E(now());
  }
  function j() {
    var f = now(), _ = D(f);
    if (n = arguments, o = this, u = f, _) {
      if (l === void 0)
        return F(u);
      if (m)
        return l = setTimeout(P, t), p(u);
    }
    return l === void 0 && (l = setTimeout(P, t)), a;
  }
  return j.cancel = H, j.flush = k, j;
}
function throttle(e, t, r) {
  var n = !0, o = !0;
  if (typeof e != "function")
    throw new TypeError(FUNC_ERROR_TEXT$2);
  return isObject$2(r) && (n = "leading" in r ? !!r.leading : n, o = "trailing" in r ? !!r.trailing : o), debounce(e, t, {
    leading: n,
    maxWait: t,
    trailing: o
  });
}
function isObject$2(e) {
  var t = typeof e;
  return !!e && (t == "object" || t == "function");
}
function isObjectLike$2(e) {
  return !!e && typeof e == "object";
}
function isSymbol$2(e) {
  return typeof e == "symbol" || isObjectLike$2(e) && objectToString$2.call(e) == symbolTag$2;
}
function toNumber(e) {
  if (typeof e == "number")
    return e;
  if (isSymbol$2(e))
    return NAN;
  if (isObject$2(e)) {
    var t = typeof e.valueOf == "function" ? e.valueOf() : e;
    e = isObject$2(t) ? t + "" : t;
  }
  if (typeof e != "string")
    return e === 0 ? e : +e;
  e = e.replace(reTrim, "");
  var r = reIsBinary.test(e);
  return r || reIsOctal.test(e) ? freeParseInt(e.slice(2), r ? 2 : 8) : reIsBadHex.test(e) ? NAN : +e;
}
var lodash_throttle = throttle;
function getArgs(func) {
  let paramString = extractArgs(func), pieces = [], Mode = Object.freeze({
    variable: 0,
    value: 1
  }), mode = Mode.variable, capture = "", varName, insideString, curly = 0, parenth = 0, brack = 0, escaped = !1, patternMatchedN = 0, wasPatternMatched = !1;
  for (let i = 0; i < paramString.length; i++) {
    let c = paramString[i];
    switch (mode) {
      case Mode.value:
        insideString !== void 0 ? (c === "\\" ? escaped = !0 : escaped ? escaped = !1 : c === insideString && (insideString = void 0), capture += c) : c === '"' || c === "'" ? (insideString = c, capture += c) : c === "{" ? (curly++, capture += c) : c === "}" ? (curly--, capture += c) : c === "(" ? (parenth++, capture += c) : c === ")" ? (parenth--, capture += c) : c === "," && parenth === 0 && curly === 0 ? (pieces.push([varName, eval(capture.trim())]), capture = "", mode = Mode.variable) : capture += c;
        break;
      case Mode.variable:
        curly === 0 && brack === 0 && c === "=" ? (mode = Mode.value, capture = capture.trim(), varName = capture, capture = "") : curly === 0 && brack === 0 && c === "," ? (wasPatternMatched === !0 ? (pieces.push(["__" + patternMatchedN, capture.trim()]), patternMatchedN++, wasPatternMatched = !1) : (capture = capture.trim(), pieces.push([capture, void 0])), capture = "") : c === "{" ? (curly++, wasPatternMatched = !0, capture += c) : c === "}" ? (curly--, capture += c) : c === "[" ? (brack++, wasPatternMatched = !0, capture += c) : (c === "]" && brack--, capture += c);
        break;
    }
  }
  switch (mode) {
    case Mode.variable:
      capture = capture.trim(), pieces.push([capture, void 0]);
      break;
    case Mode.value:
      pieces.push([varName, eval(capture.trim())]);
      break;
  }
  return new Map(pieces);
}
function extractArgs(e) {
  let t = resolveFunc(e).replace(/^[^]*?\(/g, ""), r, n, o = 0, s = !1;
  for (let a = 0; a < t.length; a++) {
    let l = t[a];
    if (n !== void 0)
      l === "\\" ? s = !0 : s ? s = !1 : l === n && (n = void 0);
    else if (l === "'" || l == '"')
      n = l;
    else if (l === "(")
      o++;
    else if (l === ")" && o > 0)
      o--;
    else if (l === ")") {
      r = t.substring(0, a);
      break;
    }
  }
  return r;
}
function resolveFunc(e) {
  return e.toString();
}
var getArgs_1 = getArgs;
class ReflectBase {
  constructor(t) {
    this.thing = t;
  }
}
class ReflectFunctionCallBuilder {
  constructor(t) {
    this._parameters = [], this.reflectFunction = t;
  }
  instance(t) {
    return this._instance = t, this;
  }
  prepParameters(t) {
    return t === void 0 ? [] : Array.isArray(t) ? t : [t];
  }
  parameters(...t) {
    return this._parameters = this.prepParameters(t), this;
  }
  call() {
    return this._instance ? this.reflectFunction.callWithInstance(this._instance, ...this._parameters) : this.reflectFunction.call(...this._parameters);
  }
}
class ReflectFunction extends ReflectBase {
  is() {
    const t = Reflect.apply(Object.prototype.toString, this.thing, []);
    return this.thing != null && (typeof this.thing == "object" || typeof this.thing == "function") && (t === "[object Function]" || t === "[object AsyncFunction]" || t === "[object GeneratorFunction]" || t === "[object Proxy]");
  }
  static isFunction(t) {
    return new ReflectFunction(t).is();
  }
  getParams() {
    if (this.paramsCache)
      return this.paramsCache;
    const t = [], r = getArgs_1(this.thing);
    for (let [n, o] of r.entries())
      t.push({ name: n, value: o });
    return this.paramsCache = t;
  }
  getParamNames() {
    return this.getParams().map((t) => t.name);
  }
  build() {
    return new ReflectFunctionCallBuilder(this);
  }
  call(...t) {
    return Reflect.apply(this.thing, void 0, t);
  }
  callWithInstance(t, ...r) {
    return Reflect.apply(this.thing, t, r);
  }
}
function isPropertyLike(e, t) {
  return !(e === "constructor" || ReflectFunction.isFunction(t.value));
}
class ReflectObject extends ReflectBase {
  constructor() {
    super(...arguments), this.instanceDescriptors = {}, this.descriptors = {};
  }
  getDescriptors(t = !1) {
    return this.descriptors ? this.descriptors : this.descriptors = Object.getOwnPropertyDescriptors(this.thing);
  }
  getInstanceDescriptors(t = !1) {
    return this.instanceDescriptors ? this.instanceDescriptors : this.instanceDescriptors = Object.getOwnPropertyDescriptors(this.getPrototype());
  }
  getAllDescriptors(t = !1) {
    var r;
    return (r = this.thing) != null && r.prototype ? Object.assign({}, this.getInstanceDescriptors(t), this.getDescriptors(t)) : Object.assign({}, Object.getOwnPropertyDescriptors(this.thing), Object.getOwnPropertyDescriptors(this.getPrototype()));
  }
  getPrototype() {
    let t = Reflect.getPrototypeOf(this.thing);
    return t === Function.prototype ? this.thing.prototype : t;
  }
  static getPrototypeOf(t) {
    return new ReflectObject(t).getPrototype();
  }
  hasProperty(t) {
    return Reflect.has(this.thing, t);
  }
  getPropertyValue(t) {
    return this.thing[t];
  }
  setPropertyValue(t, r) {
    this.thing[t] = r;
  }
  getPropertyNames() {
    const t = this.getAllDescriptors();
    return Object.entries(t).reduce((r, [n, o]) => (isPropertyLike(n, o) && r.push(n), r), []);
  }
  getPropertyDescriptors() {
    return Object.entries(this.getAllDescriptors()).reduce((t, [r, n]) => (isPropertyLike(r, n) && (t[r] = n), t), {});
  }
  deleteKey(t) {
    let r = !1;
    return Reflect.has(this.thing, t) && (Reflect.deleteProperty(this.thing, t), r = !0), Reflect.has(this.getPrototype(), t) && (Reflect.deleteProperty(this.getPrototype(), t), r = !0), this.descriptors[t] && delete this.descriptors[t], this.instanceDescriptors[t] && delete this.instanceDescriptors[t], r;
  }
  addProperty(t, r, n) {
    var o, s, a;
    if (this.hasProperty(t))
      throw new Error(`Property ${t} already exists on ${this.thing}`);
    Reflect.defineProperty(this.getPrototype(), t, {
      value: r,
      writable: (o = n == null ? void 0 : n.writable) != null ? o : !0,
      enumerable: (s = n == null ? void 0 : n.enumerable) != null ? s : !0,
      configurable: (a = n == null ? void 0 : n.configurable) != null ? a : !0
    });
  }
  addGetter(t, r, n) {
    var o, s;
    if (this.hasProperty(t))
      throw new Error(`Property ${t} already exists on ${this.thing}`);
    const a = this.getDescriptors()[t];
    Reflect.defineProperty(this.getPrototype(), t, {
      set: a == null ? void 0 : a.set,
      get: r,
      enumerable: (o = n == null ? void 0 : n.enumerable) != null ? o : !0,
      configurable: (s = n == null ? void 0 : n.configurable) != null ? s : !0
    });
  }
  addSetter(t, r, n) {
    var o, s;
    if (this.hasProperty(t))
      throw new Error(`Property ${t} already exists on ${this.thing}`);
    const a = this.getDescriptors()[t];
    Reflect.defineProperty(this.getPrototype(), t, {
      set: r,
      get: a == null ? void 0 : a.get,
      enumerable: (o = n == null ? void 0 : n.enumerable) != null ? o : !0,
      configurable: (s = n == null ? void 0 : n.configurable) != null ? s : !0
    });
  }
  addAccessor(t, r, n, o) {
    var s, a;
    if (this.hasProperty(t))
      throw new Error(`Property ${t} already exists on ${this.thing}`);
    Reflect.defineProperty(this.getPrototype(), t, {
      set: n,
      get: r,
      enumerable: (s = o == null ? void 0 : o.enumerable) != null ? s : !0,
      configurable: (a = o == null ? void 0 : o.configurable) != null ? a : !0
    });
  }
}
const objectProto$2 = Reflect.getPrototypeOf(Object);
class ReflectClass extends ReflectObject {
  constructor(t) {
    super(t), this.thing = t;
  }
  isInstantiated() {
    return this.thing !== this.getConstructor();
  }
  getConstructor() {
    return ReflectFunction.isFunction(this.thing) ? this.thing : this.thing.constructor;
  }
  static getConstructorOf(t) {
    return new ReflectClass(t).getConstructor();
  }
  getExtensions() {
    let t = this.getConstructor();
    const r = [];
    do
      t = Reflect.getPrototypeOf(t), t !== Object.prototype && t !== Function.prototype && t !== void 0 ? r.push(t) : t = void 0;
    while (t !== void 0);
    return r;
  }
  extends(t) {
    let r = this.getConstructor(), n = ReflectClass.getConstructorOf(t);
    do {
      if (r === n)
        return !0;
      r = Reflect.getPrototypeOf(r);
    } while (r !== Object.prototype && r !== objectProto$2);
    return !1;
  }
  hasMethod(t) {
    return ReflectFunction.isFunction(this.getPrototype()[t]);
  }
  getMethod(t) {
    const r = this.getPrototype()[t];
    return ReflectFunction.isFunction(r) ? r : void 0;
  }
  getMethods() {
    return Reflect.ownKeys(this.getPrototype()).reduce((t, r) => (r === "constructor" || ReflectFunction.isFunction(this.getPrototype()[r]) && (t[r] = this.getPrototype()[r]), t), {});
  }
  getMethodNames() {
    return Reflect.ownKeys(this.thing).filter((t) => ReflectFunction.isFunction(this.thing[t]));
  }
  getMethodDescriptors() {
    return Reflect.ownKeys(this.thing).reduce((t, r) => (ReflectFunction.isFunction(this.thing[r]) && (t[r] = Reflect.getOwnPropertyDescriptor(this.thing, r)), t), {});
  }
  method(t) {
    const r = this.getMethod(t);
    if (!r)
      throw new Error(`Cannot find method ${t} on ${this.getConstructor().name}.`);
    return new ReflectFunction(r);
  }
  addMethod(t, r, n = {}) {
    if (this.getInstanceDescriptors()[t])
      throw new Error(`Cannot add method ${t} to ${this.getConstructor().name} because it already exists.`);
    if (!ReflectFunction.isFunction(r))
      throw new Error(`Cannot add method ${t} to ${this.getConstructor().name} because it is not a function.`);
    return Reflect.defineProperty(this.getPrototype(), t, {
      value: r.bind(this.thing),
      writable: n.writable,
      enumerable: n.enumerable,
      configurable: n.configurable
    }), this.getInstanceDescriptors(!0), this;
  }
  addStaticMethod(t, r, n = {}) {
    if (this.getDescriptors()[t])
      throw new Error(`Cannot add method ${t} to ${this.getConstructor().name} because it already exists.`);
    if (!ReflectFunction.isFunction(r))
      throw new Error(`Cannot add method ${t} to ${this.getConstructor().name} because it is not a function.`);
    return Reflect.defineProperty(this.thing, t, {
      value: r.bind(this.thing),
      writable: n.writable,
      enumerable: n.enumerable,
      configurable: n.configurable
    }), this.getInstanceDescriptors(!0), this;
  }
}
class ReflectApi {
  constructor(t) {
    this.thing = t;
  }
  isObjectLike(t) {
    return this.thing != null && typeof this.thing == "object";
  }
  class() {
    return new ReflectClass(this.thing);
  }
  object() {
    return new ReflectObject(this.thing);
  }
  function() {
    return new ReflectFunction(this.thing);
  }
}
function reflect(e) {
  return new ReflectApi(e);
}
function isPlainObject(e) {
  return e && typeof e == "object" && Object.prototype.toString.call(e) === "[object Object]" && typeof e.toJSON != "function";
}
function mergeReactiveObjects(e, t) {
  e instanceof Map && t instanceof Map && t.forEach((r, n) => e.set(n, r)), e instanceof Set && t instanceof Set && t.forEach(e.add, e);
  for (const r in t) {
    if (!t.hasOwnProperty(r))
      continue;
    const n = t[r], o = e[r];
    isPlainObject(o) && isPlainObject(n) && e.hasOwnProperty(r) && !isRef(n) && !isReactive(n) ? e[r] = mergeReactiveObjects(o, n) : e[r] = n;
  }
  return e;
}
const noop = () => {
};
class Subscription {
  constructor() {
    h(this, "callbacks", []);
  }
  addSubscription(t, r = { detached: !1, onCleanup: noop }) {
    const n = {
      callback: t,
      options: r,
      disposer: () => {
        const o = this.callbacks.indexOf(n);
        o > -1 && (this.callbacks.splice(o, 1), r.onCleanup());
      }
    };
    return this.callbacks.push(n), !r.detached && getCurrentScope() && onScopeDispose(n.disposer), n;
  }
  subscribe(t, r = { detached: !1, onCleanup: noop }) {
    return this.addSubscription(t, r).disposer;
  }
  trigger(...t) {
    !this.hasSubscriptions() || this.callbacks.slice().forEach(({ callback: r }) => {
      r(...t);
    });
  }
  triggerPiped(...t) {
    let r = t;
    return this.hasSubscriptions() && this.callbacks.slice().forEach(({ callback: n }) => {
      r = n.call(null, ...r);
    }), r;
  }
  hasSubscriptions() {
    var t;
    return !!((t = this.callbacks) != null && t.length);
  }
}
const ClassStoreSymbol = Symbol("ClassStore");
function makeReactive(e) {
  return isRef(e) ? e : ref(e);
}
function getDescriptorsGrouped(e, t = []) {
  const r = {
    state: {},
    getters: {},
    setters: {},
    actions: {},
    other: {}
  };
  t.push(
    "__proto__",
    "hasOwnProperty",
    "isPrototypeOf",
    "propertyIsEnumerable",
    "toLocaleString",
    "toString",
    "valueOf",
    "__defineGetter__",
    "__defineSetter__",
    "__lookupGetter__",
    "__lookupSetter__"
  );
  const n = Object.getOwnPropertyDescriptors(e);
  for (let o in n) {
    if (t.includes(o))
      continue;
    const s = n[o];
    if (s.get && !s.set && !s.value) {
      r.getters[o] = s;
      continue;
    }
    if (s.get && s.set && !s.value) {
      r.state[o] = s;
      continue;
    }
    if (s.set && !s.get && !s.value) {
      r.setters[o] = s;
      continue;
    }
    if (!s.set && !s.get && s.value) {
      if (typeof s.value == "function") {
        r.actions[o] = s;
        continue;
      }
      if (isPlainObject(s.value)) {
        r.getters[o] = s;
        continue;
      }
    }
    r.other[o] = s;
  }
  if (e.__proto__) {
    const o = getDescriptorsGrouped(e.__proto__, t);
    for (const s in o)
      r[s] = Object.assign({}, o[s], r[s]);
  }
  return r;
}
var FUNC_ERROR_TEXT$1 = "Expected a function", HASH_UNDEFINED$1 = "__lodash_hash_undefined__", INFINITY$1 = 1 / 0, funcTag$1 = "[object Function]", genTag$1 = "[object GeneratorFunction]", symbolTag$1 = "[object Symbol]", reIsDeepProp$1 = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp$1 = /^\w*$/, reLeadingDot$1 = /^\./, rePropName$1 = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, reRegExpChar$1 = /[\\^$.*+?()[\]{}|]/g, reEscapeChar$1 = /\\(\\)?/g, reIsHostCtor$1 = /^\[object .+?Constructor\]$/, freeGlobal$1 = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal, freeSelf$1 = typeof self == "object" && self && self.Object === Object && self, root$1 = freeGlobal$1 || freeSelf$1 || Function("return this")();
function getValue$1(e, t) {
  return e == null ? void 0 : e[t];
}
function isHostObject$1(e) {
  var t = !1;
  if (e != null && typeof e.toString != "function")
    try {
      t = !!(e + "");
    } catch {
    }
  return t;
}
var arrayProto$1 = Array.prototype, funcProto$1 = Function.prototype, objectProto$1 = Object.prototype, coreJsData$1 = root$1["__core-js_shared__"], maskSrcKey$1 = function() {
  var e = /[^.]+$/.exec(coreJsData$1 && coreJsData$1.keys && coreJsData$1.keys.IE_PROTO || "");
  return e ? "Symbol(src)_1." + e : "";
}(), funcToString$1 = funcProto$1.toString, hasOwnProperty$1 = objectProto$1.hasOwnProperty, objectToString$1 = objectProto$1.toString, reIsNative$1 = RegExp(
  "^" + funcToString$1.call(hasOwnProperty$1).replace(reRegExpChar$1, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
), Symbol$2 = root$1.Symbol, splice$1 = arrayProto$1.splice, Map$2 = getNative$1(root$1, "Map"), nativeCreate$1 = getNative$1(Object, "create"), symbolProto$1 = Symbol$2 ? Symbol$2.prototype : void 0, symbolToString$1 = symbolProto$1 ? symbolProto$1.toString : void 0;
function Hash$1(e) {
  var t = -1, r = e ? e.length : 0;
  for (this.clear(); ++t < r; ) {
    var n = e[t];
    this.set(n[0], n[1]);
  }
}
function hashClear$1() {
  this.__data__ = nativeCreate$1 ? nativeCreate$1(null) : {};
}
function hashDelete$1(e) {
  return this.has(e) && delete this.__data__[e];
}
function hashGet$1(e) {
  var t = this.__data__;
  if (nativeCreate$1) {
    var r = t[e];
    return r === HASH_UNDEFINED$1 ? void 0 : r;
  }
  return hasOwnProperty$1.call(t, e) ? t[e] : void 0;
}
function hashHas$1(e) {
  var t = this.__data__;
  return nativeCreate$1 ? t[e] !== void 0 : hasOwnProperty$1.call(t, e);
}
function hashSet$1(e, t) {
  var r = this.__data__;
  return r[e] = nativeCreate$1 && t === void 0 ? HASH_UNDEFINED$1 : t, this;
}
Hash$1.prototype.clear = hashClear$1;
Hash$1.prototype.delete = hashDelete$1;
Hash$1.prototype.get = hashGet$1;
Hash$1.prototype.has = hashHas$1;
Hash$1.prototype.set = hashSet$1;
function ListCache$1(e) {
  var t = -1, r = e ? e.length : 0;
  for (this.clear(); ++t < r; ) {
    var n = e[t];
    this.set(n[0], n[1]);
  }
}
function listCacheClear$1() {
  this.__data__ = [];
}
function listCacheDelete$1(e) {
  var t = this.__data__, r = assocIndexOf$1(t, e);
  if (r < 0)
    return !1;
  var n = t.length - 1;
  return r == n ? t.pop() : splice$1.call(t, r, 1), !0;
}
function listCacheGet$1(e) {
  var t = this.__data__, r = assocIndexOf$1(t, e);
  return r < 0 ? void 0 : t[r][1];
}
function listCacheHas$1(e) {
  return assocIndexOf$1(this.__data__, e) > -1;
}
function listCacheSet$1(e, t) {
  var r = this.__data__, n = assocIndexOf$1(r, e);
  return n < 0 ? r.push([e, t]) : r[n][1] = t, this;
}
ListCache$1.prototype.clear = listCacheClear$1;
ListCache$1.prototype.delete = listCacheDelete$1;
ListCache$1.prototype.get = listCacheGet$1;
ListCache$1.prototype.has = listCacheHas$1;
ListCache$1.prototype.set = listCacheSet$1;
function MapCache$1(e) {
  var t = -1, r = e ? e.length : 0;
  for (this.clear(); ++t < r; ) {
    var n = e[t];
    this.set(n[0], n[1]);
  }
}
function mapCacheClear$1() {
  this.__data__ = {
    hash: new Hash$1(),
    map: new (Map$2 || ListCache$1)(),
    string: new Hash$1()
  };
}
function mapCacheDelete$1(e) {
  return getMapData$1(this, e).delete(e);
}
function mapCacheGet$1(e) {
  return getMapData$1(this, e).get(e);
}
function mapCacheHas$1(e) {
  return getMapData$1(this, e).has(e);
}
function mapCacheSet$1(e, t) {
  return getMapData$1(this, e).set(e, t), this;
}
MapCache$1.prototype.clear = mapCacheClear$1;
MapCache$1.prototype.delete = mapCacheDelete$1;
MapCache$1.prototype.get = mapCacheGet$1;
MapCache$1.prototype.has = mapCacheHas$1;
MapCache$1.prototype.set = mapCacheSet$1;
function assocIndexOf$1(e, t) {
  for (var r = e.length; r--; )
    if (eq$1(e[r][0], t))
      return r;
  return -1;
}
function baseGet(e, t) {
  t = isKey$1(t, e) ? [t] : castPath$1(t);
  for (var r = 0, n = t.length; e != null && r < n; )
    e = e[toKey$1(t[r++])];
  return r && r == n ? e : void 0;
}
function baseIsNative$1(e) {
  if (!isObject$1(e) || isMasked$1(e))
    return !1;
  var t = isFunction$1(e) || isHostObject$1(e) ? reIsNative$1 : reIsHostCtor$1;
  return t.test(toSource$1(e));
}
function baseToString$1(e) {
  if (typeof e == "string")
    return e;
  if (isSymbol$1(e))
    return symbolToString$1 ? symbolToString$1.call(e) : "";
  var t = e + "";
  return t == "0" && 1 / e == -INFINITY$1 ? "-0" : t;
}
function castPath$1(e) {
  return isArray$1(e) ? e : stringToPath$1(e);
}
function getMapData$1(e, t) {
  var r = e.__data__;
  return isKeyable$1(t) ? r[typeof t == "string" ? "string" : "hash"] : r.map;
}
function getNative$1(e, t) {
  var r = getValue$1(e, t);
  return baseIsNative$1(r) ? r : void 0;
}
function isKey$1(e, t) {
  if (isArray$1(e))
    return !1;
  var r = typeof e;
  return r == "number" || r == "symbol" || r == "boolean" || e == null || isSymbol$1(e) ? !0 : reIsPlainProp$1.test(e) || !reIsDeepProp$1.test(e) || t != null && e in Object(t);
}
function isKeyable$1(e) {
  var t = typeof e;
  return t == "string" || t == "number" || t == "symbol" || t == "boolean" ? e !== "__proto__" : e === null;
}
function isMasked$1(e) {
  return !!maskSrcKey$1 && maskSrcKey$1 in e;
}
var stringToPath$1 = memoize$1(function(e) {
  e = toString$1(e);
  var t = [];
  return reLeadingDot$1.test(e) && t.push(""), e.replace(rePropName$1, function(r, n, o, s) {
    t.push(o ? s.replace(reEscapeChar$1, "$1") : n || r);
  }), t;
});
function toKey$1(e) {
  if (typeof e == "string" || isSymbol$1(e))
    return e;
  var t = e + "";
  return t == "0" && 1 / e == -INFINITY$1 ? "-0" : t;
}
function toSource$1(e) {
  if (e != null) {
    try {
      return funcToString$1.call(e);
    } catch {
    }
    try {
      return e + "";
    } catch {
    }
  }
  return "";
}
function memoize$1(e, t) {
  if (typeof e != "function" || t && typeof t != "function")
    throw new TypeError(FUNC_ERROR_TEXT$1);
  var r = function() {
    var n = arguments, o = t ? t.apply(this, n) : n[0], s = r.cache;
    if (s.has(o))
      return s.get(o);
    var a = e.apply(this, n);
    return r.cache = s.set(o, a), a;
  };
  return r.cache = new (memoize$1.Cache || MapCache$1)(), r;
}
memoize$1.Cache = MapCache$1;
function eq$1(e, t) {
  return e === t || e !== e && t !== t;
}
var isArray$1 = Array.isArray;
function isFunction$1(e) {
  var t = isObject$1(e) ? objectToString$1.call(e) : "";
  return t == funcTag$1 || t == genTag$1;
}
function isObject$1(e) {
  var t = typeof e;
  return !!e && (t == "object" || t == "function");
}
function isObjectLike$1(e) {
  return !!e && typeof e == "object";
}
function isSymbol$1(e) {
  return typeof e == "symbol" || isObjectLike$1(e) && objectToString$1.call(e) == symbolTag$1;
}
function toString$1(e) {
  return e == null ? "" : baseToString$1(e);
}
function get(e, t, r) {
  var n = e == null ? void 0 : baseGet(e, t);
  return n === void 0 ? r : n;
}
var lodash_get = get, FUNC_ERROR_TEXT = "Expected a function", HASH_UNDEFINED = "__lodash_hash_undefined__", INFINITY = 1 / 0, MAX_SAFE_INTEGER = 9007199254740991, funcTag = "[object Function]", genTag = "[object GeneratorFunction]", symbolTag = "[object Symbol]", reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, reIsPlainProp = /^\w*$/, reLeadingDot = /^\./, rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, reRegExpChar = /[\\^$.*+?()[\]{}|]/g, reEscapeChar = /\\(\\)?/g, reIsHostCtor = /^\[object .+?Constructor\]$/, reIsUint = /^(?:0|[1-9]\d*)$/, freeGlobal = typeof commonjsGlobal == "object" && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal, freeSelf = typeof self == "object" && self && self.Object === Object && self, root = freeGlobal || freeSelf || Function("return this")();
function getValue(e, t) {
  return e == null ? void 0 : e[t];
}
function isHostObject(e) {
  var t = !1;
  if (e != null && typeof e.toString != "function")
    try {
      t = !!(e + "");
    } catch {
    }
  return t;
}
var arrayProto = Array.prototype, funcProto = Function.prototype, objectProto = Object.prototype, coreJsData = root["__core-js_shared__"], maskSrcKey = function() {
  var e = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || "");
  return e ? "Symbol(src)_1." + e : "";
}(), funcToString = funcProto.toString, hasOwnProperty = objectProto.hasOwnProperty, objectToString = objectProto.toString, reIsNative = RegExp(
  "^" + funcToString.call(hasOwnProperty).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
), Symbol$1 = root.Symbol, splice = arrayProto.splice, Map$1 = getNative(root, "Map"), nativeCreate = getNative(Object, "create"), symbolProto = Symbol$1 ? Symbol$1.prototype : void 0, symbolToString = symbolProto ? symbolProto.toString : void 0;
function Hash(e) {
  var t = -1, r = e ? e.length : 0;
  for (this.clear(); ++t < r; ) {
    var n = e[t];
    this.set(n[0], n[1]);
  }
}
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
}
function hashDelete(e) {
  return this.has(e) && delete this.__data__[e];
}
function hashGet(e) {
  var t = this.__data__;
  if (nativeCreate) {
    var r = t[e];
    return r === HASH_UNDEFINED ? void 0 : r;
  }
  return hasOwnProperty.call(t, e) ? t[e] : void 0;
}
function hashHas(e) {
  var t = this.__data__;
  return nativeCreate ? t[e] !== void 0 : hasOwnProperty.call(t, e);
}
function hashSet(e, t) {
  var r = this.__data__;
  return r[e] = nativeCreate && t === void 0 ? HASH_UNDEFINED : t, this;
}
Hash.prototype.clear = hashClear;
Hash.prototype.delete = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;
function ListCache(e) {
  var t = -1, r = e ? e.length : 0;
  for (this.clear(); ++t < r; ) {
    var n = e[t];
    this.set(n[0], n[1]);
  }
}
function listCacheClear() {
  this.__data__ = [];
}
function listCacheDelete(e) {
  var t = this.__data__, r = assocIndexOf(t, e);
  if (r < 0)
    return !1;
  var n = t.length - 1;
  return r == n ? t.pop() : splice.call(t, r, 1), !0;
}
function listCacheGet(e) {
  var t = this.__data__, r = assocIndexOf(t, e);
  return r < 0 ? void 0 : t[r][1];
}
function listCacheHas(e) {
  return assocIndexOf(this.__data__, e) > -1;
}
function listCacheSet(e, t) {
  var r = this.__data__, n = assocIndexOf(r, e);
  return n < 0 ? r.push([e, t]) : r[n][1] = t, this;
}
ListCache.prototype.clear = listCacheClear;
ListCache.prototype.delete = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;
function MapCache(e) {
  var t = -1, r = e ? e.length : 0;
  for (this.clear(); ++t < r; ) {
    var n = e[t];
    this.set(n[0], n[1]);
  }
}
function mapCacheClear() {
  this.__data__ = {
    hash: new Hash(),
    map: new (Map$1 || ListCache)(),
    string: new Hash()
  };
}
function mapCacheDelete(e) {
  return getMapData(this, e).delete(e);
}
function mapCacheGet(e) {
  return getMapData(this, e).get(e);
}
function mapCacheHas(e) {
  return getMapData(this, e).has(e);
}
function mapCacheSet(e, t) {
  return getMapData(this, e).set(e, t), this;
}
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype.delete = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;
function assignValue(e, t, r) {
  var n = e[t];
  (!(hasOwnProperty.call(e, t) && eq(n, r)) || r === void 0 && !(t in e)) && (e[t] = r);
}
function assocIndexOf(e, t) {
  for (var r = e.length; r--; )
    if (eq(e[r][0], t))
      return r;
  return -1;
}
function baseIsNative(e) {
  if (!isObject(e) || isMasked(e))
    return !1;
  var t = isFunction(e) || isHostObject(e) ? reIsNative : reIsHostCtor;
  return t.test(toSource(e));
}
function baseSet(e, t, r, n) {
  if (!isObject(e))
    return e;
  t = isKey(t, e) ? [t] : castPath(t);
  for (var o = -1, s = t.length, a = s - 1, l = e; l != null && ++o < s; ) {
    var u = toKey(t[o]), d = r;
    if (o != a) {
      var b = l[u];
      d = n ? n(b, u, l) : void 0, d === void 0 && (d = isObject(b) ? b : isIndex(t[o + 1]) ? [] : {});
    }
    assignValue(l, u, d), l = l[u];
  }
  return e;
}
function baseToString(e) {
  if (typeof e == "string")
    return e;
  if (isSymbol(e))
    return symbolToString ? symbolToString.call(e) : "";
  var t = e + "";
  return t == "0" && 1 / e == -INFINITY ? "-0" : t;
}
function castPath(e) {
  return isArray(e) ? e : stringToPath(e);
}
function getMapData(e, t) {
  var r = e.__data__;
  return isKeyable(t) ? r[typeof t == "string" ? "string" : "hash"] : r.map;
}
function getNative(e, t) {
  var r = getValue(e, t);
  return baseIsNative(r) ? r : void 0;
}
function isIndex(e, t) {
  return t = t == null ? MAX_SAFE_INTEGER : t, !!t && (typeof e == "number" || reIsUint.test(e)) && e > -1 && e % 1 == 0 && e < t;
}
function isKey(e, t) {
  if (isArray(e))
    return !1;
  var r = typeof e;
  return r == "number" || r == "symbol" || r == "boolean" || e == null || isSymbol(e) ? !0 : reIsPlainProp.test(e) || !reIsDeepProp.test(e) || t != null && e in Object(t);
}
function isKeyable(e) {
  var t = typeof e;
  return t == "string" || t == "number" || t == "symbol" || t == "boolean" ? e !== "__proto__" : e === null;
}
function isMasked(e) {
  return !!maskSrcKey && maskSrcKey in e;
}
var stringToPath = memoize(function(e) {
  e = toString(e);
  var t = [];
  return reLeadingDot.test(e) && t.push(""), e.replace(rePropName, function(r, n, o, s) {
    t.push(o ? s.replace(reEscapeChar, "$1") : n || r);
  }), t;
});
function toKey(e) {
  if (typeof e == "string" || isSymbol(e))
    return e;
  var t = e + "";
  return t == "0" && 1 / e == -INFINITY ? "-0" : t;
}
function toSource(e) {
  if (e != null) {
    try {
      return funcToString.call(e);
    } catch {
    }
    try {
      return e + "";
    } catch {
    }
  }
  return "";
}
function memoize(e, t) {
  if (typeof e != "function" || t && typeof t != "function")
    throw new TypeError(FUNC_ERROR_TEXT);
  var r = function() {
    var n = arguments, o = t ? t.apply(this, n) : n[0], s = r.cache;
    if (s.has(o))
      return s.get(o);
    var a = e.apply(this, n);
    return r.cache = s.set(o, a), a;
  };
  return r.cache = new (memoize.Cache || MapCache)(), r;
}
memoize.Cache = MapCache;
function eq(e, t) {
  return e === t || e !== e && t !== t;
}
var isArray = Array.isArray;
function isFunction(e) {
  var t = isObject(e) ? objectToString.call(e) : "";
  return t == funcTag || t == genTag;
}
function isObject(e) {
  var t = typeof e;
  return !!e && (t == "object" || t == "function");
}
function isObjectLike(e) {
  return !!e && typeof e == "object";
}
function isSymbol(e) {
  return typeof e == "symbol" || isObjectLike(e) && objectToString.call(e) == symbolTag;
}
function toString(e) {
  return e == null ? "" : baseToString(e);
}
function set(e, t, r) {
  return e == null ? e : baseSet(e, t, r);
}
var lodash_set = set;
const InternalStoreKeys = [
  "constructor",
  "state",
  "vueBinding",
  "$watch",
  "$patch",
  "$reset",
  "$onAction",
  "$getState",
  "__addExtensions",
  "__addExtension",
  "__setState",
  "__originalState",
  "__state",
  "__stateWatcherFuncs",
  "__descriptors",
  "__handlers",
  "__actionHandlers",
  "__actionSubscriptions"
];
var U, O, N, C, M, w, R, v, T, I, A;
class BaseStore {
  constructor() {
    $(this, O);
    $(this, C);
    $(this, w);
    $(this, v);
    $(this, I);
    h(this, "__originalState");
    h(this, "__state");
    h(this, "__stateWatcherFuncs", {});
    h(this, U, null);
    h(this, "__descriptors", {});
    h(this, "__handlers", new Subscription());
    h(this, "__actionHandlers", []);
    h(this, "__actionSubscriptions", {
      after: new Subscription(),
      before: new Subscription(),
      error: new Subscription()
    });
    this.__originalState = klona(this.state), this.__state = klona(this.state), Object.defineProperty(this, "state", { value: {}, configurable: !0 }), y(this, C, M).call(this, this.__originalState), this[ClassStoreSymbol] = this.constructor, this.__descriptors = getDescriptorsGrouped(this, InternalStoreKeys), y(this, w, R).call(this);
  }
  $reset() {
    for (let [t, r] of Object.entries(this.__originalState))
      this.__state[t].value = r;
    DevTools.updateStore(this);
  }
  get $watch() {
    return this.__stateWatcherFuncs;
  }
  $getState(t, r) {
    return lodash_get(this.__state, t, r);
  }
  __setState(t, r) {
    lodash_set(this.__state, t, r);
  }
  $patch(t) {
    if (typeof t == "function") {
      t(this.state);
      return;
    }
    mergeReactiveObjects(this.state, t);
  }
  $onAction(t) {
    return this.__handlers.subscribe(t);
  }
  __addExtensions(t) {
    for (let r of t)
      this.__addExtension(r);
  }
  __addExtension(t) {
    const r = getDescriptorsGrouped(t, InternalStoreKeys);
    ({ ...r.getters, ...r.other });
    for (let [n, o] of Object.entries(r.getters))
      Object.defineProperty(this, n, { enumerable: !0, configurable: !0, value: t[n] }), this.__descriptors.getters[n] = o;
    for (let [n, o] of Object.entries(r.other))
      Object.defineProperty(this, n, { enumerable: !0, configurable: !0, value: t[n] }), this.__descriptors.other[n] = o;
    for (let [n, o] of Object.entries(r.actions))
      y(this, v, T).call(this, n, o), this.__descriptors.actions[n] = o;
  }
}
U = ClassStoreSymbol, O = new WeakSet(), N = function(t) {
  const r = (n) => {
    this.__state[t].value = n, DevTools.updateStore(this);
  };
  Object.defineProperty(this.state, t, {
    get: () => this.__state[t].value,
    set: r
  }), Object.defineProperty(this, "$" + t, {
    get: () => this.__state[t].value,
    set: r
  }), Object.defineProperty(this.__stateWatcherFuncs, t, {
    value: (n, o) => y(this, I, A).call(this, t, n, o)
  });
}, C = new WeakSet(), M = function(t) {
  if (!t)
    throw new Error("State object is not defined...");
  for (let [r, n] of Object.entries(t))
    this.__state[r] = makeReactive(t[r]), y(this, O, N).call(this, r);
}, w = new WeakSet(), R = function() {
  for (let t in this.__descriptors.actions) {
    const r = this.__descriptors.actions[t];
    y(this, v, T).call(this, t, r);
  }
}, v = new WeakSet(), T = function(t, r) {
  Object.defineProperty(this, t, {
    value: (...n) => {
      const o = reflect(r.value).function().build().instance(this);
      if (!this.__handlers.hasSubscriptions())
        return o.parameters(n).call();
      const s = new Subscription(), a = new Subscription(), l = new Subscription();
      n = n || [];
      function u(p) {
        s.addSubscription(p);
      }
      function d(p) {
        a.addSubscription(p);
      }
      function b(p) {
        l.addSubscription(p);
      }
      const m = {
        before: u,
        after: d,
        error: b,
        args: n,
        name: t,
        store: this
      };
      this.__handlers.trigger(m);
      let g;
      try {
        g = o.parameters(s.triggerPiped(...n)).call();
      } catch (p) {
        throw l.trigger(p), p;
      }
      return g instanceof Promise ? g.then((p) => (a.trigger(p), p)).catch((p) => (l.trigger(p), Promise.reject(p))) : (a.trigger(g), g);
    }
  });
}, I = new WeakSet(), A = function(t, r, n) {
  var l;
  const o = (l = n == null ? void 0 : n.stopOnScopeDispose) != null ? l : !0, s = {
    deep: n.deep,
    flush: n.flush,
    immediate: n.immediate,
    onTrack: n.onTrack,
    onTrigger: n.onTrigger
  };
  this.$getState(t);
  const a = watch(
    this.$getState(t),
    (u, d) => {
      r(u, d);
    },
    s
  );
  if (o) {
    if (!getCurrentScope())
      throw new Error("No scope found. Are you using the plugin outside of a Vue component/setup?");
    onScopeDispose(() => a());
  }
  return a;
};
var LoggerLevel = /* @__PURE__ */ ((e) => (e[e.Error = 0] = "Error", e[e.Warn = 1] = "Warn", e[e.Info = 2] = "Info", e[e.Success = 3] = "Success", e[e.Debug = 4] = "Debug", e))(LoggerLevel || {});
const baseStyle = [
  "color: #fff",
  "background-color: #444",
  "padding: 4px 6px",
  "border-radius: 4px",
  "font-size: 12px",
  "font-weight: bold"
], logStyles = {
  [4]: [
    ...baseStyle,
    "background-color: #444"
  ],
  [2]: [
    ...baseStyle,
    "background-color: #0ea5e9"
  ],
  [3]: [
    ...baseStyle,
    "background-color: #059669"
  ],
  [1]: [
    ...baseStyle,
    "background-color: #f59e0b",
    "color: #000"
  ],
  [0]: [
    ...baseStyle,
    "background-color: #ef4444"
  ]
};
class LoggerInstance {
  constructor() {
    h(this, "level", 3);
    h(this, "_label", "");
  }
  setLevel(t) {
    this.level = t;
  }
  canLog(t) {
    return this.level >= t;
  }
  label(t) {
    const r = new LoggerInstance();
    return r.setLevel(this.level), r.setLabel(t), r;
  }
  logMessage(t, ...r) {
    if (!this.canLog(t))
      return;
    const n = logStyles[t].join(";") + ";", o = LoggerLevel[t].toUpperCase(), s = 5 - o.length;
    let a = s > 0 ? " ".repeat(s) : "";
    const l = [
      `%c${o}`,
      n,
      a
    ];
    this._label && l.push(`${this._label} - `), console.log(...l, ...r);
  }
  debug(...t) {
    this.logMessage(4, ...t);
  }
  info(...t) {
    this.logMessage(2, ...t);
  }
  success(...t) {
    this.logMessage(3, ...t);
  }
  warn(...t) {
    this.logMessage(1, ...t);
  }
  error(...t) {
    this.logMessage(0, ...t);
  }
  setLabel(t) {
    this._label = t;
  }
}
const Logger = new LoggerInstance();
class StoreManagerInstance {
  constructor() {
    h(this, "app");
    h(this, "didInstantiateStores", !1);
    h(this, "stores", {});
    h(this, "storeModules", {});
    h(this, "storeMeta", {});
    h(this, "storeBindingToClassName", {});
    h(this, "extensions", []);
  }
  boot() {
    if (!(arguments != null && arguments.length)) {
      Logger.error("StoreManager boot called without arguments... this could be a problem with the vue-class-stores vite plugin, please report this on github! <3");
      return;
    }
    const t = arguments[0];
    if (!t)
      throw new Error("Store loader is not defined");
    const r = Object.values(t)[0];
    if (!r)
      throw new Error("Store loader is not defined");
    return {
      install: (n) => {
        this.bootFromLoader(n, r);
      }
    };
  }
  bootFromLoader(t, r) {
    if (!r)
      throw new Error("Store loader is not defined");
    this.app = t, this.loadStoresFromLoader(r), DevTools.isAvailable() && DevTools.setup(t), this.didInstantiateStores = !0;
  }
  handleHotReload(t) {
  }
  loadStoresFromLoader(t) {
    for (let r of t.stores)
      this.loadStore(r);
  }
  loadStore(t) {
    const r = t.module();
    if (!r)
      throw new Error("Store lazy import; module is not defined for file: " + t.importPath);
    const n = Object.values(r)[0];
    if (!n)
      throw new Error("Store module is not defined for file: " + t.importPath);
    const o = n[t.exportName];
    o.vueBinding = t.vueBinding, this.storeModules[t.className] = n, this.storeMeta[t.className] = t, this.stores[t.className] = o, this.storeBindingToClassName[t.vueBinding] = t.className, this.app.config.globalProperties[t.vueBinding] = o, o.__addExtensions(this.extensions.map((s) => s())), Logger.label("StoreManager").success("Registered store: ", o);
  }
  addExtensions() {
    Object.entries(this.stores).forEach(([t, r]) => {
      r.__addExtensions(this.extensions.map((n) => n()));
    });
  }
  extend(t) {
    this.extensions.push(t), this.didInstantiateStores && this.addExtensions();
  }
}
const storeManager = new StoreManagerInstance();
class StoreApi {
  constructor(t, r) {
    h(this, "store");
    h(this, "meta");
    this.store = t, this.meta = r;
  }
  static forBinding(t) {
    const r = storeManager.storeBindingToClassName[t];
    if (!r)
      throw new Error(`No store found for binding: ${t}`);
    return StoreApi.forClass(r);
  }
  static forBindingDevTools(t) {
    const r = storeManager.storeBindingToClassName[t];
    if (!r)
      throw new Error(`No store found for binding: ${t}`);
    const n = StoreApi.forClass(r);
    return { store: n, instance: n.getInstance() };
  }
  static forClass(t) {
    const r = storeManager.storeMeta[t];
    if (!r)
      throw new Error(`No store found for binding: ${t}`);
    const n = storeManager.stores[t];
    if (!n)
      throw new Error(`No store found for binding: ${t}`);
    return new StoreApi(n, r);
  }
  getInstance() {
    return this.store;
  }
  getMeta() {
    return this.meta;
  }
  getAllState() {
    return this.store.__state;
  }
  getAllGetters() {
    return Object.entries(this.store.__descriptors.getters);
  }
  getAllActions() {
    return this.meta.actions.map((t) => [t.name, {
      ...t,
      value: this.store[t.name]
    }]);
  }
  getName() {
    return this.store.constructor.name;
  }
  getVueBinding() {
    return this.store.vueBinding;
  }
  setState(t, r) {
    console.log("Set state: " + t + " = " + r), this.store.__setState(t, r);
  }
}
const inspectorId = "vue-class-stores-plugin";
class DevtoolsInstance {
  constructor() {
    h(this, "api");
    h(this, "selectedInspectorNode", { nodeId: null, storeBinding: null });
  }
  isAvailable() {
    return window.__VUE_DEVTOOLS_GLOBAL_HOOK__ !== void 0;
  }
  setup(t) {
    setupDevtoolsPlugin({
      id: inspectorId,
      label: "Vue Class Stores",
      packageName: "vue-class-stores",
      app: t
    }, this.configurePlugin.bind(this));
  }
  configurePlugin(t) {
    this.api = t, this.api.addInspector({
      id: inspectorId,
      label: "Class Stores",
      icon: "receipt_long",
      noSelectionText: "Select a store to inspect it",
      actions: [
        {
          icon: "delete_sweep",
          tooltip: "Reset selected store",
          action: () => {
            var r;
            if (!((r = this.selectedInspectorNode) != null && r.nodeId)) {
              console.warn("No store selected, click one of your stores first.");
              return;
            }
            StoreApi.forBinding(this.selectedInspectorNode.nodeId).getInstance().$reset();
          }
        }
      ]
    }), this.api.on.inspectComponent(this.onInspectComponent.bind(this)), this.api.on.editComponentState(this.onEditComponentState.bind(this)), this.api.on.getInspectorTree(this.onGetInspectorTree.bind(this)), this.api.on.getInspectorState(this.onGetInspectorState.bind(this)), this.api.on.editInspectorState(this.onEditInspectorState.bind(this));
  }
  onGetInspectorTree(t, r) {
    if (t.inspectorId === inspectorId) {
      t.rootNodes = [];
      for (let n in storeManager.stores) {
        const o = StoreApi.forClass(n), s = {
          id: o.getVueBinding(),
          label: o.getName(),
          tags: [
            {
              label: o.getVueBinding(),
              textColor: 0,
              backgroundColor: 16750671
            }
          ]
        };
        t.rootNodes.push(s);
      }
    }
  }
  onGetInspectorState(t, r) {
    if (t.inspectorId !== inspectorId)
      return;
    const { store: n, instance: o } = StoreApi.forBindingDevTools(t.nodeId);
    this.selectedInspectorNode = {
      nodeId: t.nodeId,
      storeBinding: n.getVueBinding()
    }, t.state = {
      "1. State": this.mapInspectorState(n.getAllState()),
      "2. Getters": this.mapInspectorGetters({ store: n, instance: o }, n.getAllGetters()),
      "3. Actions": this.mapInspectorActions({ store: n, instance: o })
    };
  }
  onEditInspectorState(t, r) {
    var s;
    if (t.inspectorId !== inspectorId || t.type !== "1. State")
      return;
    const { store: n, instance: o } = StoreApi.forBindingDevTools(t.nodeId);
    t.set(n.getAllState(), t.path, (s = t.state) == null ? void 0 : s.value);
  }
  mapInspectorState(t) {
    return Object.entries(t).map(([r, n]) => ({
      key: r,
      editable: !0,
      objectType: "ref",
      value: n.value
    }));
  }
  mapInspectorGetters({ store: t, instance: r }, n) {
    return n.map(([o, s]) => ({
      key: o,
      editable: !1,
      objectType: "computed",
      value: s.get.call(r)
    }));
  }
  mapInspectorActions({ instance: t, store: r }) {
    return r.getAllActions().map(([n, o]) => ({
      key: `${n}(${o.params.map(
        (a) => a.name + (a.type ? ":" + a.type : "") + (a.defaultValue ? ` = ${a.defaultValue}` : "")
      ).join(", ")})`,
      value: {
        _custom: {
          type: "function",
          id: n,
          abstract: !0,
          actions: [
            {
              icon: "smart_button",
              tooltip: "Call Action",
              action: async (a, l) => {
                try {
                  let u = t[n].call(t);
                  u instanceof Promise && (u = await u), console.log(n + "() => ", u);
                } catch (u) {
                  console.log(n + "() => ", u);
                }
              }
            }
          ]
        }
      }
    }));
  }
  onInspectComponent(t, r) {
    for (let n of t.instanceData.state) {
      if (!(n.value instanceof BaseStore))
        continue;
      const { store: o, instance: s } = StoreApi.forBindingDevTools(n.value.vueBinding);
      n.storeRef = s, n.editable = !0, n.objectType = "reactive", n.value = {
        _custom: {
          value: Object.entries(o.getAllState()).reduce((a, [l, u]) => (a[l] = u, a), {})
        }
      };
    }
  }
  onEditComponentState(t, r) {
  }
  updateStore(t) {
    !this.api || lodash_throttle(() => this.api.sendInspectorState(inspectorId), 100)();
  }
}
const DevTools = new DevtoolsInstance();
export {
  DevTools,
  DevtoolsInstance
};
//# sourceMappingURL=index.js.map
